class ComplaintBuilder < Builder
  ##
  # receive a list of ids and return a list of complaints
  #
  def self.build(complaints = [])
    super(complaint_repository, complaints)
  end

  def self.build_from_orientdb(args = {})
    unless args.blank?
      created = DateTime.now.strftime("%Y-%m-%d %H:%M:%S")
      created = DateTime.strptime(args['created_at'], "%Y-%m-%d %H:%M:%S") unless args['created_at'].blank?

      Orientdb::Complaint.new(
        id: args['@rid'],
        user: user_repository.get_by_rid(args['out']),
        created_at: created,
        object: learning_object_repository.find(args['in'].to_s),
        message: Orientdb::ComplaintMessage.new(args['message']),
        description: args['description'] || ''
      )
    end
  end

end
