class Orientdb::Subject
  include ActiveModel::Model
  include RepositoriesProxy

  attr_accessor :id, :highlights, :name,
                :created_at, :last_modified,
                :learning_objects, :subtopics, :supertopics

  def highlights
    @highlights ||= subject_repository.get_highlights(self)
  end

  def learning_objects
    @learning_objects ||= subject_repository.get_learning_objects(self)
  end

  def subtopics
    @subtopics ||= subject_repository.get_subtopics(self)
  end

  def supertopics
    @supertopics ||= subject_repository.get_supertopics(self)
  end

  def self.default_list
    ['Artes', 'Biologia', 'Ciências', 'Educação Física', 'Filosofia',
     'Física', 'Geografia', 'História', 'Matemática', 'Língua Portuguesa', 'Química', 'Sociologia'].map do |subject|
      new.subject_repository.find_by_name(subject)
    end
  end
end
