class OrientDb::Associations::PublisherAssociation < OrientDb::Association

  def can_create?
    if !@object.publisher.nil?
      return !edge_exists?("PublishedBy", @object.id, publisher_id(@object.publisher))
    end
  end

  protected

  def execute
    create_edge("PublishedBy", @object.id, publisher_id(@object.publisher))
  end

  def publisher_id(publisher)
    if publisher.class.name == "User"
      publisher.rid
    elsif publisher.class.name == "Institution"
      publisher.id
    end
  end

end

