require 'yaml'

orientdb_client = OrientdbService.create_client

repositories = {
    learning_object: OrientDb::LearningObjectRepository.new(orientdb_client),
    language: OrientDb::LanguageRepository.new(orientdb_client),
    user: UserRepositoryProxy.new(OrientDb::UserRepository.new(orientdb_client)),
    subject: OrientDb::SubjectRepository.new(orientdb_client),
    institution: OrientDb::InstitutionRepository.new(orientdb_client),
    attribute: OrientDb::AttributeRepository.new(orientdb_client),
    collection: OrientDb::CollectionRepository.new(orientdb_client),
    carousel: ActiveRecord::CarouselRepository.new,
    complaint: OrientDb::ComplaintRepository.new(orientdb_client),
    role: ActiveRecord::RoleRepository.new
}

# initialize default application repositories
Repository::Environments.create :default, repositories

# initialize test application repositories
Repository::Environments.create :test, repositories