module OrientDb

  ##abstract class Association
  # A Relation represents an edge in orient db. It's a relation between two objects.
  class Association
    include OrientDb::Methods::EdgeMethods

    def initialize(object, connection)
      @object = object
      @connection = connection
    end

    def can_create?
      raise NotImplementedError, 'Relation#can_execute? is an abstract method.'
    end

    def create
      execute if can_create?
    end

    protected

    attr_accessor :connection

    def execute
      raise NotImplementedError, 'Relation#execute is an abstract method.'
    end

  end
end