class OrientDb::Migrations::CreateLearningObject < OrientDb::Migration

  def up
    create_class 'LearningObject', 'Object' do |c|
        c.property 'id_dspace', :long, :mandatory => true, :notnull => true
        c.property 'main_bitstream_id', :long
        c.property 'description', :string
        c.property 'thumbnail', :string
        c.property 'type', :string
        c.property 'author', :string
        c.property 'grade_level', :string
        c.property 'score', :float
        c.property 'published_at', :datetime
        c.property 'metadata', :embeddedlist
        c.property 'bitstreams', :embeddedlist
    end
    add_index 'LearningObject', ['id_dspace'], "UNIQUE_HASH_INDEX"
    metadata = {:analyzer => "org.apache.lucene.analysis.br.BrazilianAnalyzer"}
    add_index 'LearningObject', ['name'], "FULLTEXT", nil, "LUCENE", metadata.to_json
    add_index 'LearningObject', ['description'], "FULLTEXT", nil, "LUCENE", metadata.to_json
    add_index 'LearningObject', ['author'], "FULLTEXT", nil, "LUCENE", metadata.to_json
  end

  def down
    drop_class 'LearningObject'
  end
end