require 'test_helper'
require 'test_model_repository'

class Repository::EnvironmentsTest < ActiveSupport::TestCase

  def setup
    Repository::Environments.create :test_env do |repository|
      repository.register :test_model, TestModelRepository.new
    end
  end

  test 'can create a repositories inside env' do
    Repository::Environments.create :test_specific_env do |repository|
      repository.register :test_model, TestModelRepository.new
    end

    assert_count 1, Repository::Environments.fetch(:test_specific_env).repositories
  end

  test 'select a repository by environment' do
    assert Repository::Environments.fetch(:test_env).for(:test_model).working?
  end

end